Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.scheduling.quartz
Class QuartzJobBean

    java.lang.Object
      org.springframework.scheduling.quartz.QuartzJobBean

All Implemented Interfaces:
  org.quartz.Job

Direct Known Subclasses:
  MethodInvokingJobDetailFactoryBean.MethodInvokingJob

    public abstract class QuartzJobBean

extends java.lang.Object
implements org.quartz.Job

Simple implementation of the Quartz Job interface, applying the passed-in JobDataMap and also the SchedulerContext as bean property values. This is appropriate because a new Job instance will be created for each execution. JobDataMap entries will override SchedulerContext entries with the same keys.

For example, let's assume that the JobDataMap contains a key "myParam" with value "5": The Job implementation can then expose a bean property "myParam" of type int to receive such a value, i.e. a method "setMyParam(int)". This will also work for complex types like business objects etc.

Note: The QuartzJobBean class itself only implements the standard Quartz `Job` interface. Let your subclass explicitly implement the Quartz `StatefulJob` interface to mark your concrete job bean as stateful.

This version of QuartzJobBean requires Quartz 1.5 or higher, due to the support for trigger-specific job data.

Note that as of Spring 2.0 and Quartz 1.5, the preferred way to apply dependency injection to Job instances is via a JobFactory: that is, to specify `SpringBeanJobFactory` as Quartz JobFactory (typically via `SchedulerFactoryBean.setJobFactory(org.quartz.spi.JobFactory)` SchedulerFactoryBean's "jobFactory" property}). This allows to implement dependency-injected Quartz Jobs without a dependency on Spring base classes.

Since:
  18.02.2004
Author:
  Juergen Hoeller
See Also:
  `JobExecutionContext.getMergedJobDataMap()`, `Scheduler.getContext()`, `JobDetailBean.setJobDataAsMap(java.util.Map)`, `SimpleTriggerBean.setJobDataAsMap(java.util.Map)`, `CronTriggerBean.setJobDataAsMap(java.util.Map)`, `SchedulerFactoryBean.setSchedulerContextAsMap(java.util.Map)`, `SpringBeanJobFactory`, `SchedulerFactoryBean.setJobFactory(org.quartz.spi.JobFactory)`

Constructor Summary
`QuartzJobBean()`

Method Summary
`void` | `execute(org.quartz.JobExecutionContext context)` This implementation applies the passed-in job data map as bean property values, and delegates to `executeInternal` afterwards.
`protected abstract void` | `executeInternal(org.quartz.JobExecutionContext context)` Execute the actual job.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### QuartzJobBean

    public QuartzJobBean()

Method Detail

### execute

    public final void execute(org.quartz.JobExecutionContext context)
                       throws org.quartz.JobExecutionException

  This implementation applies the passed-in job data map as bean property values, and delegates to `executeInternal` afterwards.

  Specified by:
    `execute` in interface `org.quartz.Job`
  Throws:
    `org.quartz.JobExecutionException`
  See Also:
    `executeInternal(org.quartz.JobExecutionContext)`

### executeInternal

    protected abstract void executeInternal(org.quartz.JobExecutionContext context)
                                     throws org.quartz.JobExecutionException

  Execute the actual job. The job data map will already have been applied as bean property values by execute. The contract is exactly the same as for the standard Quartz execute method.

  Throws:
    `org.quartz.JobExecutionException`
  See Also:
    `execute(org.quartz.JobExecutionContext)`

Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD